namespace AutoGenerateColumns
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using System.Drawing;

    using Telerik.Reporting;
    using Telerik.Reporting.Drawing;

    /// <summary>
    /// Summary description for Report1.
    /// </summary>
    public partial class Report1 : Telerik.Reporting.Report
    {
        public Report1()
        {
            //
            // Required for telerik Reporting designer support
            //
            InitializeComponent();
            BuildReport();
            //
            // TODO: Add any constructor code after InitializeComponent call
            //
        }


        private void BuildReport()
        {
            Telerik.Reporting.Table tbl = new Telerik.Reporting.Table();


            //styles
            tbl.Style.BorderWidth.Default = new Unit(1D, UnitType.Pixel);
            tbl.Style.BorderStyle.Default = BorderType.Solid;

            //body columns
            Unit columnWidth = Unit.Inch(0.1);
            tbl.Body.Columns.AddRange(new TableBodyColumn[] {
        new TableBodyColumn(columnWidth),
        new TableBodyColumn(columnWidth),
        new TableBodyColumn(columnWidth),
        new TableBodyColumn(columnWidth),
        new TableBodyColumn(columnWidth),
        new TableBodyColumn(columnWidth),
        new TableBodyColumn(columnWidth),
        new TableBodyColumn(columnWidth),
        new TableBodyColumn(columnWidth),
        new TableBodyColumn(columnWidth),
        new TableBodyColumn(columnWidth),
        new TableBodyColumn(columnWidth)
    });

            //column groups
            for (int idx = 0; idx < tbl.Body.Columns.Count; idx++)
            {
                TableGroup group = new TableGroup();
                group.Name = "colgroup" + idx.ToString();
                tbl.ColumnGroups.Add(group);
            }

            //data
            var fieldComps = new List<ModelTableFieldComposition_Flatten>();
            fieldComps.Add(new ModelTableFieldComposition_Flatten { DisplayName = "test1", FieldLabelVisible = true, ReportFieldLabelColumnSpan = 1 });
            fieldComps.Add(new ModelTableFieldComposition_Flatten { DisplayName = "test2" + Environment.NewLine + "test", FieldLabelVisible = true, ReportFieldLabelColumnSpan = 4 });
            fieldComps.Add(new ModelTableFieldComposition_Flatten { DisplayName = "test3 123", FieldLabelVisible = true, ReportFieldLabelColumnSpan = 1 });

            //rows
            int rowNumber = 0;
            for (int idx = 0; idx < fieldComps.Count; idx++)
            {
                ModelTableFieldComposition_Flatten field = fieldComps[idx];
                GetLabelRow(field, tbl, ref rowNumber);
            }

            //add to detail section
            tbl.Size = new SizeU(Unit.Inch(1.2), Unit.Inch(0.3));
            this.DetailSection.Items.AddRange(new ReportItemBase[] { tbl });
        }

        private void GetLabelRow(ModelTableFieldComposition_Flatten field, Table tbl, ref int rowNumber)
        {
            //row group
            TableGroup tableGroupRow = new TableGroup();
            tableGroupRow.Name = "rowgroup" + rowNumber.ToString();
            tbl.RowGroups.Add(tableGroupRow);
            tbl.Body.Rows.Add(new TableBodyRow(Unit.Inch(0.1D)));


            //first cell
            Telerik.Reporting.TextBox labelTextBox = new Telerik.Reporting.TextBox();
            labelTextBox.Name = "labelField_row" + rowNumber.ToString();
            labelTextBox.Value = field.DisplayName;
            labelTextBox.Visible = field.FieldLabelVisible;


            labelTextBox.Size = new SizeU(Unit.Inch(0.1 * field.ReportFieldLabelColumnSpan), Unit.Inch(0.1));
            labelTextBox.Style.BorderStyle.Default = Telerik.Reporting.Drawing.BorderType.Solid;
            labelTextBox.Style.BorderWidth.Default = Unit.Pixel(1D);
            labelTextBox.Style.Font.Name = "Segoe UI";
            labelTextBox.Style.Font.Size = Unit.Point(10);
            labelTextBox.Style.VerticalAlign = Telerik.Reporting.Drawing.VerticalAlign.Middle;
            labelTextBox.Style.BackgroundColor = Color.Wheat;
            labelTextBox.Style.Color = Color.Black;

            tbl.Body.SetCellContent(rowNumber, 0, labelTextBox, 0, field.ReportFieldLabelColumnSpan);
            tbl.Items.AddRange(new ReportItemBase[] { labelTextBox });


            //set row's cells content
            int colIndex = field.ReportFieldLabelColumnSpan;

            while (colIndex < 12)
            {
                Telerik.Reporting.TextBox emptyLabelTextBox = new Telerik.Reporting.TextBox();
                emptyLabelTextBox.Name = "emptyField_row" + rowNumber.ToString() + "_col_" + colIndex.ToString();
                emptyLabelTextBox.Value = string.Empty;

                emptyLabelTextBox.Size = new SizeU(Unit.Inch(0.1), Unit.Inch(0.1));
                emptyLabelTextBox.Style.BorderStyle.Default = Telerik.Reporting.Drawing.BorderType.Solid;
                emptyLabelTextBox.Style.BorderWidth.Default = Unit.Pixel(1D);
                emptyLabelTextBox.Style.Font.Name = "Segoe UI";
                emptyLabelTextBox.Style.VerticalAlign = Telerik.Reporting.Drawing.VerticalAlign.Middle;

                tbl.Body.SetCellContent(rowNumber, colIndex, emptyLabelTextBox);
                tbl.Items.AddRange(new ReportItemBase[] { emptyLabelTextBox });

                colIndex++;
            }

            rowNumber++;
        }

    }
}